## libpodofo 0.9.7+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

#*****************  IMPORTANT  ************* IMPORTANT **********************
# Look at http://www.vtk.org/Wiki/CMake_HowToDoPlatformChecks
# and the other wiki entries before you add anything. You might not need to.
#****************************************************************************

#
# Project name and version
#
PROJECT(PoDoFo)

SET(PODOFO_VERSION_MAJOR "0" CACHE STRING "Major part of PoDoFo version number")
SET(PODOFO_VERSION_MINOR "9" CACHE STRING "Minor part of PoDoFo version number")
SET(PODOFO_VERSION_PATCH "7" CACHE STRING "Patchlevel part of PoDoFo version number")
SET(PODOFO_SOVERSION "${PODOFO_VERSION_MAJOR}.${PODOFO_VERSION_MINOR}.${PODOFO_VERSION_PATCH}")
SET(PODOFO_LIBVERSION "${PODOFO_SOVERSION}")


#
# Main includes
#
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckLibraryExists)
INCLUDE(TestBigEndian)
INCLUDE(CheckTypeSize)

#
# Setup CMake Policies
#

# Prefer files in CMAKE_MODULE_PATH over shipped ones in module directory
CMAKE_POLICY(SET CMP0017 NEW) # https://cmake.org/cmake/help/v3.0/policy/CMP0017.html
# Do not use export_library_dependencies() anymore
if(POLICY CMP0033)
CMAKE_POLICY(SET CMP0033 NEW) # https://cmake.org/cmake/help/v3.0/policy/CMP0033.html
endif()

# Load modules from our source tree too
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")


# Builds must use this CMakeLists.txt, not the one in src/ or somewhere else.
# If users try to use something else the results can be confusing. We set a
# variable here that we require to be set elsewhere, otherwise we'll complain.
SET(PODOFO_MAIN_CMAKELISTS_READ TRUE)

# If the user hasn't told use specifically what they want, build only
# a static library or only a shared library on Windows.
IF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
    IF(WIN32)
        SET(PODOFO_BUILD_STATIC FALSE)
        SET(PODOFO_BUILD_SHARED TRUE)
    ELSE(WIN32)
        SET(PODOFO_BUILD_STATIC TRUE)
        SET(PODOFO_BUILD_SHARED FALSE)
    ENDIF(WIN32)
ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
IF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
    IF(PODOFO_BUILD_SHARED)
        SET(PODOFO_BUILD_STATIC FALSE)
    ELSE(PODOFO_BUILD_SHARED)
        SET(PODOFO_BUILD_STATIC TRUE)
    ENDIF(PODOFO_BUILD_SHARED)
ENDIF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
IF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)
    IF(PODOFO_BUILD_STATIC)
        SET(PODOFO_BUILD_SHARED FALSE)
    ELSE(PODOFO_BUILD_STATIC)
        SET(PODOFO_BUILD_SHARED TRUE)
    ENDIF(PODOFO_BUILD_STATIC)
ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)

IF(DEFINED LIB_SUFFIX)
	SET(LIBDIRNAME "lib${LIB_SUFFIX}")
ELSE(DEFINED LIB_SUFFIX)

# Some 64 bit linux distros use /usr/lib64 for 64 bit libraries.
# on these platforms we must
IF(NOT DEFINED WANT_LIB64)
	# TODO: detect 64-bit build and existance of /usr/lib64 and set to TRUE.
	MESSAGE("WANT_LIB64 unset; assuming normal library directory names")
	SET(WANT_LIB64 FALSE)
ENDIF(NOT DEFINED WANT_LIB64)

IF(WANT_LIB64)
	SET(LIBDIRNAME "lib64")
ELSE(WANT_LIB64)
	SET(LIBDIRNAME "lib")
ENDIF(WANT_LIB64)

ENDIF(DEFINED LIB_SUFFIX)
MESSAGE("Will install libraries to ${CMAKE_INSTALL_PREFIX}/${LIBDIRNAME}")

CHECK_CXX_SOURCE_COMPILES("#include <memory>
			class Cls {
			public:
			Cls() {}
			~Cls() {}
			};
			int main(void) { std::unique_ptr<Cls> cls; return 0; }" PODOFO_HAVE_UNIQUE_PTR)

# Some headers that tend to vary a bit
CHECK_INCLUDE_FILE("strings.h" PODOFO_HAVE_STRINGS_H) 
CHECK_INCLUDE_FILE("arpa/inet.h" PODOFO_HAVE_ARPA_INET_H) 
CHECK_INCLUDE_FILE("winsock2.h" PODOFO_HAVE_WINSOCK2_H) 
CHECK_INCLUDE_FILE("mem.h" PODOFO_HAVE_MEM_H) 
CHECK_INCLUDE_FILE("ctype.h" PODOFO_HAVE_CTYPE_H) 

# Do some type size detection and provide yet another set of typedefs for fixed
# font sizes. We can't use the c99 / c++0x uint32_t etc, because people use
# ancient compilers that don't and will never support the standard.

CHECK_INCLUDE_FILE("sys/types.h" PODOFO_HAVE_SYS_TYPES_H) 
CHECK_INCLUDE_FILE("stdint.h" PODOFO_HAVE_STDINT_H) 
# See: http://msdn.microsoft.com/en-us/library/aa384264(VS.85).aspx
CHECK_INCLUDE_FILE("BaseTsd.h" PODOFO_HAVE_BASETSD_H) 

CHECK_TYPE_SIZE("long int" SZ_LONG)

# We cache integer type detection results, and don't repeat them
# (and overwrite the user's manual changes) if they've been done already.
IF(NOT PDF_INT64_TYPENAME)
  # I hate old compilers.
  IF(PODOFO_HAVE_STDINT_H)
    SET(pdfint8 "int8_t")
    SET(pdfint16 "int16_t")
    SET(pdfint32 "int32_t")
    SET(pdfint64 "int64_t")
    SET(pdfuint8 "uint8_t")
    SET(pdfuint16 "uint16_t")
    SET(pdfuint32 "uint32_t")
    SET(pdfuint64 "uint64_t")
    CHECK_TYPE_SIZE("int64_t" SZ_INT64)
  ELSE(PODOFO_HAVE_STDINT_H)
    # No stdint.h . Try BaseTsd.h windows types.
    IF(PODOFO_HAVE_BASETSD_H)
       # We have BaseTsd.h, so use those types.
       SET(pdfint8  "signed char")
       SET(pdfint16 "short")
       SET(pdfint32 "INT32")
       SET(pdfint64 "INT64")
       SET(pdfuint8 "unsigned char")
       SET(pdfuint16 "unsigned short")
       SET(pdfuint32 "UINT32")
       SET(pdfuint64 "UINT64")
       CHECK_TYPE_SIZE("INT64" SZ_INT64)
    ELSE(PODOFO_HAVE_BASETSD_H)
       # No BaseTsd.h either. Assume the standard types, and go poking
       # for a sane 64-bit integer.
       #
       # First, though, make sure sizeof(int) = 4 and if not, scream, because
       # hopefully this case will never be hit and we'll never have to write
       # the horrible code check for
       CHECK_TYPE_SIZE("signed char"        SZ_TINY_INT)
       CHECK_TYPE_SIZE("unsigned char"      SZ_TINY_UINT)
       CHECK_TYPE_SIZE("short int"          SZ_SHORT_INT)
       CHECK_TYPE_SIZE("int"                SZ_INT)
       CHECK_TYPE_SIZE("unsigned short int" SZ_UINT)
       CHECK_TYPE_SIZE("unsigned int"       SZ_SHORT_UINT)
       SET(smallintsok SZ_INT == 4 AND SZ_UINT == 4 AND SZ_SHORT_INT == 2 AND SZ_SHORT_UINT == 2 AND SZ_TINY_INT == 1 AND SZ_TINY_UINT == 1)
       IF(NOT smallintsok)
         MESSAGE(FATAL "sizeof(int) != 4 and/or sizeof(short) != 2 and no stdint.h or BaseTsd.h found. We don't know how to cope with this.")
       ENDIF(NOT smallintsok)
       SET(pdfint8 "signed char")
       SET(pdfint16 "short")
       SET(pdfint32 "int")
       SET(pdfuint8 "unsigned char")
       SET(pdfuint16 "unsigned short")
       SET(pdfuint32 "unsigned int")
       # Now we just have to figure out what 64-bit integer type we can use.
       #
       # Do we have VC >= 6's __uint64 and __int64?
       # See: http://icfun.blogspot.com/2008/04/use-of-int64-variable-in-c.html
       CHECK_TYPE_SIZE("__int64" SZ___INT64)
       CHECK_TYPE_SIZE("__uint64"  SZ___UINT64)
       IF(SZ___INT64 == 8 AND SZ___UINT64 == 8)
         # MS compiler, VC6 or newer without BaseTsd.h in SDK
         SET(pdfint64 "__int64")
         SET(pdfuint64 "__uint64")
	 CHECK_TYPE_SIZE("__int64" SZ_INT64)
       ELSE(SZ___INT64 AND SZ___UINT64)
         # Still no luck. Old unix compiler, Borland, or some other monster?
         # Are we lucky and sizeof(long) == 8?
         CHECK_TYPE_SIZE("unsigned long int" SZ_ULONG)
         IF(SZ_LONG == 8 AND SZ_ULONG == 8)
           # Must be on a LP64 platform, sizeof(long) = 8
           SET(pdfint64 "long int")
           SET(pdfuint64 "unsigned long int")
	   CHECK_TYPE_SIZE("long int" SZ_INT64)
         ELSE(SZ_LONG == 8 AND SZ_ULONG == 8)
           # See if the compiler implements "long long int", int64_t, int64,
           # or _int64 (in this order, __int64 check already done)
           IF(PODOFO_HAVE_SYS_TYPES_H)
             SET(CMAKE_EXTRA_INCLUDE_FILES "sys/types.h")
           ENDIF(PODOFO_HAVE_SYS_TYPES_H)
           CHECK_TYPE_SIZE("long long int"          SZ_LONG_LONG)
           CHECK_TYPE_SIZE("unsigned long long int" SZ_UNSIGNED_LONG_LONG)
           IF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
             SET(pdfint64 "long long int")
             SET(pdfuint64 "unsigned long long int")
             CHECK_TYPE_SIZE("long long int" SZ_INT64)
           ELSE(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
             # The standard type int64_t is normally found in stdint.h,
             # but use a type of this name anyway if present
             CHECK_TYPE_SIZE("int64_t"       SZ_INT64_T)
             CHECK_TYPE_SIZE("uint64_t"      SZ_UINT64_T)
             IF(SZ_INT64_T AND SZ_UINT64_T)
               SET(pdfint64 "int64_t")
               SET(pdfuint64 "uint64_t")
	       CHECK_TYPE_SIZE("int64_t" SZ_INT64)
             ELSE(SZ_INT64_T AND SZ_UINT64_T)
               CHECK_TYPE_SIZE("int64"                SZ_INT64)
               CHECK_TYPE_SIZE("uint64"               SZ_UINT64)
               IF(SZ_INT64 AND SZ_UINT64)
                 SET(pdfint64 "int64")
                 SET(pdfuint64 "uint64")
		 CHECK_TYPE_SIZE("int64" SZ_INT64)
               ELSE(SZ_INT64 AND SZ_UINT64)
                 CHECK_TYPE_SIZE("_int64"                SZ__INT64)
                 CHECK_TYPE_SIZE("_uint64"               SZ__UINT64)
                 IF(SZ__INT64 AND SZ__UINT64)
                   SET(pdfint64 "_int64")
                   SET(pdfuint64 "_uint64")
		   CHECK_TYPE_SIZE("_int64" SZ_INT64)
                 ELSE(SZ__INT64 AND SZ__UINT64)
                   MESSAGE("Oh my lord, your compiler doesn't seem to support any of the int64 type flavours we tried.")
                   MESSAGE(WARNING "You must set the PDF_INTxx_TYPENAME and PDF_UINTxx_TYPENAME variables manually")
                 ENDIF(SZ__INT64 AND SZ__UINT64)
               ENDIF(SZ_INT64 AND SZ_UINT64)
             ENDIF(SZ_INT64_T AND SZ_UINT64_T)
           ENDIF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
         ENDIF(SZ_LONG == 8 AND SZ_ULONG == 8)
       ENDIF(SZ___INT64 AND SZ___UINT64)
    ENDIF(PODOFO_HAVE_BASETSD_H)
  ENDIF(PODOFO_HAVE_STDINT_H)
  SET(CMAKE_EXTRA_INCLUDE_FILES)
ENDIF(NOT PDF_INT64_TYPENAME)

IF(NOT PDF_INT64_TYPENAME AND pdfint64)
  SET(PDF_INT64_TYPENAME  "${pdfint64}" CACHE STRING "Name of detected 64-bit signed integer type to use")
  SET(PDF_INT32_TYPENAME  "${pdfint32}" CACHE STRING "Name of detected 32-bit signed integer type to use")
  SET(PDF_INT16_TYPENAME  "${pdfint16}" CACHE STRING "Name of detected 16-bit signed integer type to use")
  SET(PDF_INT8_TYPENAME   "${pdfint8}" CACHE STRING "Name of detected 8-bit signed integer type to use")
  SET(PDF_UINT64_TYPENAME "${pdfuint64}" CACHE STRING "Name of detected 64-bit unsigned integer type to use")
  SET(PDF_UINT32_TYPENAME "${pdfuint32}" CACHE STRING "Name of detected 32-bit unsigned integer type to use")
  SET(PDF_UINT16_TYPENAME "${pdfuint16}" CACHE STRING "Name of detected 16-bit unsigned integer type to use")
  SET(PDF_UINT8_TYPENAME  "${pdfuint8}" CACHE STRING "Name of detected 8-bit unsigned integer type to use")
ENDIF(NOT PDF_INT64_TYPENAME AND pdfint64)

# Linux packagers want an uninstall target.
CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall "${CMAKE_COMMAND}"
    -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Check if we are big endian
TEST_BIG_ENDIAN(TEST_BIG)

IF(WIN32)
    # We must explicitly link to the core win32 libraries, and we need winsock2
    # to get some byte-order conversion routines too.
    SET(PLATFORM_SYSTEM_LIBRARIES kernel32 user32 gdi32 winspool comdlg32 advapi32 shell32 ole32 oleaut32 uuid ws2_32)
    # Microsoft deprecate certain POSIX functions that we use.
    # for now, turn off these warnings.
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    # We need a fake unistd.h for some libraries to build. They try to include <unistd.h>
    # which is not available under win32 with MSVC++, but everything in unistd.h is defined,
    # so an empty file solves the issue.

=== tools/CMakeLists.txt ===
SUBDIRS(
	podofobox
	podofocolor
        podofocountpages
        podofocrop
	podofoencrypt
	podofogc
	podofoimgextract
	podofoimg2pdf
	podofomerge
	podofopages
	podofopdfinfo
	podofotxt2pdf
	podofotxtextract
	podofouncompress
	podofoimpose
	podofoincrementalupdates
	podofoxmp
	podofonooc
	)

IF(PODOFO_HAVE_OPENSSL)
	SUBDIRS(podofosign)
ENDIF(PODOFO_HAVE_OPENSSL)

=== src/podofo/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

IF(NOT PODOFO_MAIN_CMAKELISTS_READ)
  MESSAGE(FATAL_ERROR "Run cmake on the CMakeLists.txt in the project root, not the one in the 'src' directory. You will need to delete CMakeCache.txt from the current directory.")
ENDIF(NOT PODOFO_MAIN_CMAKELISTS_READ)

SET(PODOFO_BASE_DEPEND_TARGET CACHE INTERNAL
    "Which PoDoFo library target to depend on when building tools and tests")
SET(PODOFO_DEPEND_TARGET CACHE INTERNAL
    "Which PoDoFo library target to depend on when building tools and tests")

SET(PODOFO_BASE_SOURCES
  base/PdfArray.cpp
  base/PdfCanvas.cpp
  base/PdfColor.cpp
  base/PdfContentsTokenizer.cpp
  base/PdfData.cpp
  base/PdfDataType.cpp
  base/PdfOwnedDataType.cpp
  base/PdfDate.cpp
  base/PdfDictionary.cpp
  base/PdfEncoding.cpp
  base/PdfEncodingFactory.cpp
  base/PdfEncrypt.cpp
  base/PdfError.cpp
  base/PdfFileStream.cpp
  base/PdfFilter.cpp
  base/PdfFiltersPrivate.cpp
  base/PdfImmediateWriter.cpp
  base/PdfInputDevice.cpp
  base/PdfInputStream.cpp
  base/PdfLocale.cpp
  base/PdfMemStream.cpp
  base/PdfMemoryManagement.cpp
  base/PdfName.cpp
  base/PdfObject.cpp
  base/PdfObjectStreamParserObject.cpp
  base/PdfOutputDevice.cpp
  base/PdfOutputStream.cpp
  base/PdfParser.cpp
  base/PdfParserObject.cpp
  base/PdfRect.cpp
  base/PdfRefCountedBuffer.cpp
  base/PdfRefCountedInputDevice.cpp
  base/PdfReference.cpp
  base/PdfStream.cpp
  base/PdfString.cpp
  base/PdfTokenizer.cpp
  base/PdfVariant.cpp
  base/PdfVecObjects.cpp
  base/PdfWriter.cpp
  base/PdfXRef.cpp
  base/PdfXRefStream.cpp
  base/PdfXRefStreamParserObject.cpp
  )

SET(PODOFO_DOC_SOURCES
  doc/PdfAcroForm.cpp
  doc/PdfAction.cpp
  doc/PdfAnnotation.cpp
  doc/PdfCMapEncoding.cpp
  doc/PdfContents.cpp
  doc/PdfDestination.cpp
  doc/PdfDifferenceEncoding.cpp
  doc/PdfDocument.cpp
  doc/PdfElement.cpp
  doc/PdfEncodingObjectFactory.cpp
  doc/PdfExtGState.cpp
  doc/PdfField.cpp
  doc/PdfFileSpec.cpp
  doc/PdfFont.cpp
  doc/PdfFontCID.cpp
  doc/PdfFontCache.cpp
  doc/PdfFontConfigWrapper.cpp
  doc/PdfFontFactory.cpp
  doc/PdfFontMetrics.cpp
  doc/PdfFontMetricsBase14.cpp
  doc/PdfFontMetricsFreetype.cpp
  doc/PdfFontMetricsObject.cpp
  doc/PdfFontSimple.cpp
  doc/PdfFontTTFSubset.cpp
  doc/PdfFontTrueType.cpp
  doc/PdfFontType1.cpp
  doc/PdfFontType3.cpp
  doc/PdfFontType1Base14.cpp
  doc/PdfFunction.cpp
  doc/PdfHintStream.cpp
  doc/PdfIdentityEncoding.cpp
  doc/PdfImage.cpp
  doc/PdfInfo.cpp
  doc/PdfMemDocument.cpp
  doc/PdfNamesTree.cpp
  doc/PdfOutlines.cpp
  doc/PdfPage.cpp
  doc/PdfPagesTree.cpp
  doc/PdfPagesTreeCache.cpp
  doc/PdfPainter.cpp
  doc/PdfPainterMM.cpp
  doc/PdfShadingPattern.cpp
  doc/PdfSignOutputDevice.cpp
  doc/PdfSignatureField.cpp
  doc/PdfStreamedDocument.cpp
  doc/PdfTable.cpp
  doc/PdfTilingPattern.cpp
  doc/PdfXObject.cpp
  )

IF(WIN32)
    # If we build for windows systems, we also include the resource file
    SET(PODOFO_DOC_SOURCES ${PODOFO_DOC_SOURCES} doc/podofo-doc.rc)
ENDIF(WIN32)

SET(PODOFO_HEADERS
  podofo-base.h
  podofo.h)

SET(PODOFO_BASE_HEADERS
   ${PoDoFo_BINARY_DIR}/podofo_config.h
   base/Pdf3rdPtyForwardDecl.h
   base/PdfArray.h
   base/PdfCanvas.h
   base/PdfColor.h
   base/PdfCompilerCompat.h
   base/PdfCompilerCompatPrivate.h
   base/PdfContentsTokenizer.h
   base/PdfData.h
   base/PdfDataType.h
   base/PdfOwnedDataType.h
   base/PdfDate.h
   base/PdfDefines.h
   base/PdfDefinesPrivate.h
   base/PdfDictionary.h
   base/PdfEncoding.h
   base/PdfEncodingFactory.h
   base/PdfEncrypt.h
   base/PdfExtension.h
   base/PdfError.h
   base/PdfFileStream.h
   base/PdfFilter.h
   base/PdfFiltersPrivate.h
   base/PdfImmediateWriter.h
   base/PdfInputDevice.h
   base/PdfInputStream.h
   base/PdfLocale.h
   base/PdfMemStream.h
   base/PdfMemoryManagement.h
   base/PdfName.h
   base/PdfObject.h
   base/PdfObjectStreamParserObject.h
   base/PdfOutputDevice.h
   base/PdfOutputStream.h
   base/PdfParser.h
   base/PdfParserObject.h
   base/PdfRect.h
   base/PdfRefCountedBuffer.h
   base/PdfRefCountedInputDevice.h
   base/PdfReference.h
   base/PdfStream.h
   base/PdfString.h
   base/PdfTokenizer.h
   base/PdfVariant.h
   base/PdfVecObjects.h
   base/PdfVersion.h
   base/PdfWriter.h
   base/PdfXRef.h
   base/PdfXRefStream.h
   base/PdfXRefStreamParserObject.h
   base/podofoapi.h
   )

SET(PODOFO_BASE_HEADERS2 
    base/util/PdfMutex.h
    base/util/PdfMutexImpl_noop.h
    base/util/PdfMutexImpl_win32.h
    base/util/PdfMutexImpl_pthread.h
    base/util/PdfMutexWrapper.h
    )

SET(PODOFO_DOC_HEADERS
  doc/PdfAcroForm.h
  doc/PdfAction.h
  doc/PdfAnnotation.h
  doc/PdfCMapEncoding.h
  doc/PdfContents.h
  doc/PdfDestination.h
  doc/PdfDifferenceEncoding.h
  doc/PdfDocument.h
  doc/PdfElement.h
  doc/PdfEncodingObjectFactory.h
  doc/PdfExtGState.h
  doc/PdfField.h
  doc/PdfFileSpec.h
  doc/PdfFont.h
  doc/PdfFontCID.h
  doc/PdfFontCache.h
  doc/PdfFontConfigWrapper.h
  doc/PdfFontFactory.h
  doc/PdfFontFactoryBase14Data.h
  doc/PdfFontMetrics.h
  doc/PdfFontMetricsBase14.h
  doc/PdfFontMetricsFreetype.h
  doc/PdfFontMetricsObject.h
  doc/PdfFontSimple.h
  doc/PdfFontTTFSubset.h
  doc/PdfFontTrueType.h
  doc/PdfFontType1.h
  doc/PdfFontType3.h
  doc/PdfFontType1Base14.h
  doc/PdfFunction.h
  doc/PdfHintStream.h
  doc/PdfIdentityEncoding.h
  doc/PdfImage.h
  doc/PdfInfo.h
  doc/PdfMemDocument.h
  doc/PdfNamesTree.h
  doc/PdfOutlines.h
  doc/PdfPage.h
  doc/PdfPagesTree.h
  doc/PdfPagesTreeCache.h
  doc/PdfPainter.h
  doc/PdfPainterMM.h
  doc/PdfShadingPattern.h
  doc/PdfSignOutputDevice.h
  doc/PdfSignatureField.h
  doc/PdfStreamedDocument.h
  doc/PdfTable.h
  doc/PdfTilingPattern.h
  doc/PdfXObject.h
  )

SET(PODOFO_HEADER_FILES
  ${PODOFO_HEADERS}
  ${PODOFO_BASE_HEADERS}
  ${PODOFO_BASE_HEADERS2}
  ${PODOFO_DOC_HEADERS}
  )

# Create a Source Group for Visual Studio
# so that headers are listed in the folder view
# and are easier accessible
SOURCE_GROUP("Header Files" FILES ${PODOFO_HEADER_FILES})

INSTALL(FILES ${PODOFO_HEADERS}
  DESTINATION "include/podofo"
  )

INSTALL(FILES ${PODOFO_BASE_HEADERS}
    DESTINATION "include/podofo/base"
    )

INSTALL(FILES ${PODOFO_BASE_HEADERS2}
    DESTINATION "include/podofo/base/util"
    )

INSTALL(FILES ${PODOFO_DOC_HEADERS}
    DESTINATION "include/podofo/doc"
    )

IF(NOT PODOFO_BUILD_SHARED AND NOT PODOFO_BUILD_STATIC)
    MESSAGE(FATAL_ERROR "At least one of PODOFO_BUILD_SHARED and PODOF_BUILD_STATIC must be set")
ENDIF(NOT PODOFO_BUILD_SHARED AND NOT PODOFO_BUILD_STATIC)

IF(PODOFO_BUILD_STATIC)
    MESSAGE("Building static PoDoFo library")
    ADD_LIBRARY(podofo_static STATIC ${PODOFO_BASE_SOURCES} ${PODOFO_DOC_SOURCES} ${PODOFO_HEADER_FILES})
    TARGET_LINK_LIBRARIES(podofo_static ${PODOFO_LIB_DEPENDS})
    SET_TARGET_PROPERTIES(podofo_static PROPERTIES
        VERSION "${PODOFO_LIBVERSION}"
        SOVERSION "${PODOFO_SOVERSION}"
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "podofo"
        COMPILE_FLAGS "-DBUILDING_PODOFO"
        )
    SET(PODOFO_DEPEND_TARGET podofo_static
        CACHE INTERNAL "Which PoDoFo library variant to depend on")
    SET(USING_SHARED_PODOFO FALSE)
    INSTALL(TARGETS podofo_static
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "${LIBDIRNAME}"
        ARCHIVE DESTINATION "${LIBDIRNAME}"
        )
ENDIF(PODOFO_BUILD_STATIC)

IF(PODOFO_BUILD_SHARED)
    MESSAGE("Building shared PoDoFo library")
    ADD_LIBRARY(podofo_shared SHARED ${PODOFO_BASE_SOURCES} ${PODOFO_DOC_SOURCES} ${PODOFO_HEADER_FILES})
    TARGET_LINK_LIBRARIES(podofo_shared ${PODOFO_LIB_DEPENDS})
    # TODO: set /wd4251 flag if we're doing a debug build with
    # Visual Studio, since it produces invalid warnings about STL
    # use.
    SET_TARGET_PROPERTIES(podofo_shared PROPERTIES
        VERSION "${PODOFO_LIBVERSION}"
        SOVERSION "${PODOFO_SOVERSION}"
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "podofo"
        COMPILE_FLAGS "-DBUILDING_PODOFO"
        )
    # Since we're building a shared podofo, prefer to depend on this one for
    # tests and tools over the static library (if built).
    SET(PODOFO_DEPEND_TARGET podofo_shared
        CACHE INTERNAL "Which PoDoFo library variant to depend on")
    SET(USING_SHARED_PODOFO TRUE)
    INSTALL(TARGETS podofo_shared
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "${LIBDIRNAME}"
        ARCHIVE DESTINATION "${LIBDIRNAME}"
        )


      # Create a pkg-config file for linking against shared library
      # if pkg-config is available on the system.
      # Add a version to the file name corresponding to the API compatibility.

      FIND_PROGRAM(PKG_CONFIG_FOUND pkg-config)
      IF(PKG_CONFIG_FOUND)
        MESSAGE("Pkg-config found, creating a pkg-config file for linking against shared library.")
        CONFIGURE_FILE(
          "libpodofo.pc.in"
          "${PoDoFo_BINARY_DIR}/libpodofo.pc"
          @ONLY)
        INSTALL(
          FILES "${PoDoFo_BINARY_DIR}/libpodofo.pc"
          DESTINATION "${LIBDIRNAME}/pkgconfig")
      ELSE(PKG_CONFIG_FOUND)
        MESSAGE("Pkg-config not found. No pkg-config file will be created.")
      ENDIF(PKG_CONFIG_FOUND)
ENDIF(PODOFO_BUILD_SHARED)

# Use these flags when compiling code that includes PoDoFo headers.
# Failure to do so will result in compilation or link-time errors
# on some platforms, and can even cause undefined results at runtime.
IF(WIN32 AND USING_SHARED_PODOFO)
    SET(PODOFO_CFLAGS "-DUSING_SHARED_PODOFO" CACHE INTERNAL "Extra flags required when linking to PoDoFo")
ELSE(WIN32 AND USING_SHARED_PODOFO)
    SET(PODOFO_CFLAGS "" CACHE INTERNAL "Extra flags required when linking to PoDoFo")
ENDIF(WIN32 AND USING_SHARED_PODOFO)

# Write the cflags and depend target to the config file
FILE(APPEND 
     "${PoDoFo_BINARY_DIR}/PoDoFoConfig.cmake"
     "SET(PODOFO_CFLAGS ${PODOFO_CFLAGS})\n"
     )
FILE(APPEND
     "${PoDoFo_BINARY_DIR}/PoDoFoConfig.cmake"
     "SET(PODOFO_DEPEND_TARGET ${PODOFO_DEPEND_TARGET})\n"
     )

=== test/FormTest/CMakeLists.txt ===
ADD_EXECUTABLE(FormTest FormTest.cpp)
TARGET_LINK_LIBRARIES(FormTest ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS})
SET_TARGET_PROPERTIES(FormTest PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(FormTest ${PODOFO_DEPEND_TARGET})

=== tools/podofoimg2pdf/CMakeLists.txt ===
ADD_EXECUTABLE(podofoimg2pdf podofoimg2pdf.cpp ImageConverter.cpp)
TARGET_LINK_LIBRARIES(podofoimg2pdf ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofoimg2pdf PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofoimg2pdf ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofoimg2pdf
	RUNTIME DESTINATION "bin")

=== tools/podofomerge/CMakeLists.txt ===
ADD_EXECUTABLE(podofomerge podofomerge.cpp)
TARGET_LINK_LIBRARIES(podofomerge ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofomerge PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofomerge ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofomerge
	RUNTIME DESTINATION "bin")

=== tools/podofopages/CMakeLists.txt ===
ADD_EXECUTABLE(podofopages podofopages.cpp DeleteOperation.cpp MoveOperation.cpp)
TARGET_LINK_LIBRARIES(podofopages ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofopages PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofopages ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofopages
	RUNTIME DESTINATION "bin")

=== debian/changelog ===
libpodofo (0.9.7+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 12 Jan 2021 16:11:50 +0100

libpodofo (0.9.7+dfsg-1) experimental; urgency=medium

  * New upstream version 0.9.7+dfsg.
    + CVE-2018-11255 Closes: #916584
  * Drop all patches, applied upstream.
  * Rename library package to match the SONAME.
  * Update d/copyright.
  * Bump debhelper compat level to 13:
    + Drop dh_missing --fail-missing, now the default.
  * Bump Standards-Version to 4.5.1, no changes needed.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 09 Jan 2021 18:57:56 +0100

=== debian/control ===
Source: libpodofo
Priority: optional
Section: libdevel
Maintainer: Mattia Rizzolo <mattia@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libboost-dev,
 libcppunit-dev,
 libfontconfig1-dev,
 libfreetype6-dev (>= 2.5),
 libidn11-dev,
 libjpeg-dev,
 liblua5.1-0-dev,
 libssl-dev,
 libtiff-dev,
 libunistring-dev,
 zlib1g-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://podofo.sourceforge.net
Vcs-Git: https://salsa.debian.org/debian/libpodofo.git
Vcs-Browser: https://salsa.debian.org/debian/libpodofo

Package: libpodofo-dev
Architecture: any
Depends:
 libboost-dev,
 libpodofo0.9.7 (= ${binary:Version}),
 libssl-dev,
 ${misc:Depends},
Description: PoDoFo development files
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.
 .
 This package contains the header development files used for building
 PoDoFo-enabled applications.

Package: libpodofo-utils
Architecture: any
Section: utils
Depends:
 libpodofo0.9.7 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: PoDoFo utilities
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.
 .
 This package contains tools for working with PDF files.

Package: libpodofo0.9.7
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: PoDoFo - library to work with the PDF file format
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DWANT_FONTCONFIG:BOOL=TRUE \
	    -DWANT_BOOST:BOOL=1 \
	    -DPODOFO_BUILD_SHARED:BOOL=TRUE \
	    -DPODOFO_BUILD_STATIC:BOOL=FALSE \
	    -DPODOFO_USE_VISIBILITY:BOOL=TRUE \

override_dh_compress:
	dh_compress -X .pdf -X .plan

## libpodofo 0.9.8%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: libpodofo
 Priority: optional
 Section: libdevel
-Maintainer: Mattia Rizzolo <mattia@debian.org>
-Build-Depends:
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
+Build-Depends: dpkg-dev (>= 1.22.5),
  cmake,
  debhelper-compat (= 13),
  libboost-dev,
  libcppunit-dev,
  libfontconfig1-dev,
- libfreetype6-dev (>= 2.5),
+ libfreetype6-dev,
  libidn11-dev,
  libjpeg-dev,
  liblua5.1-0-dev,
@@ -16,7 +17,7 @@
  libtiff-dev,
  libunistring-dev,
  zlib1g-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: http://podofo.sourceforge.net
 Vcs-Git: https://salsa.debian.org/debian/libpodofo.git
@@ -26,7 +27,7 @@
 Architecture: any
 Depends:
  libboost-dev,
- libpodofo0.9.7 (= ${binary:Version}),
+ libpodofo0.9.8t64 (= ${binary:Version}),
  libssl-dev,
  ${misc:Depends},
 Description: PoDoFo development files
@@ -45,7 +46,7 @@
 Architecture: any
 Section: utils
 Depends:
- libpodofo0.9.7 (= ${binary:Version}),
+ libpodofo0.9.8t64 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: PoDoFo utilities
@@ -59,7 +60,10 @@
  .
  This package contains tools for working with PDF files.
 
-Package: libpodofo0.9.7
+Package: libpodofo0.9.8t64
+Provides: ${t64:Provides}
+Replaces: libpodofo0.9.8
+Breaks: libpodofo0.9.8 (<< ${source:Version})
 Section: libs
 Architecture: any
 Depends:

## libpodofo 0.9.8+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 SET(PODOFO_VERSION_MAJOR "0" CACHE STRING "Major part of PoDoFo version number")
 SET(PODOFO_VERSION_MINOR "9" CACHE STRING "Minor part of PoDoFo version number")
-SET(PODOFO_VERSION_PATCH "7" CACHE STRING "Patchlevel part of PoDoFo version number")
+SET(PODOFO_VERSION_PATCH "8" CACHE STRING "Patchlevel part of PoDoFo version number")
 SET(PODOFO_SOVERSION "${PODOFO_VERSION_MAJOR}.${PODOFO_VERSION_MINOR}.${PODOFO_VERSION_PATCH}")
 SET(PODOFO_LIBVERSION "${PODOFO_SOVERSION}")

=== tools/podofogc/CMakeLists.txt ===
ADD_EXECUTABLE(podofogc podofogc.cpp)

TARGET_LINK_LIBRARIES(podofogc ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofogc PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofogc ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofogc
	RUNTIME DESTINATION "bin")

=== tools/podofoincrementalupdates/CMakeLists.txt ===
ADD_EXECUTABLE(podofoincrementalupdates incrementalupdates.cpp)

TARGET_LINK_LIBRARIES(podofoincrementalupdates ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofoincrementalupdates PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofoincrementalupdates ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofoincrementalupdates
	RUNTIME DESTINATION "bin")

=== tools/podofonooc/CMakeLists.txt ===
ADD_EXECUTABLE(podofonooc podofonooc.cpp)

TARGET_LINK_LIBRARIES(podofonooc ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofonooc PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofonooc ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofonooc
	RUNTIME DESTINATION "bin")

=== tools/podofosign/CMakeLists.txt ===
ADD_EXECUTABLE(podofosign podofosign.cpp)

TARGET_INCLUDE_DIRECTORIES(podofosign PUBLIC ${LIBCRYPTO_INCLUDE_DIR})

TARGET_LINK_LIBRARIES(podofosign
	${LIBCRYPTO_LDFLAGS}
	${LIBCRYPTO_LIBRARIES}
	${OPENSSL_LIBRARIES}
	${PODOFO_LIB}
)
SET_TARGET_PROPERTIES(podofosign PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofosign ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofosign
	RUNTIME DESTINATION "bin")

=== tools/podofotxt2pdf/CMakeLists.txt ===
ADD_EXECUTABLE(podofotxt2pdf podofotxt2pdf.cpp)
TARGET_LINK_LIBRARIES(podofotxt2pdf ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofotxt2pdf PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofotxt2pdf ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofotxt2pdf
	RUNTIME DESTINATION "bin")

=== tools/podofouncompress/CMakeLists.txt ===
ADD_EXECUTABLE(podofouncompress Uncompress.cpp podofouncompress.cpp)
TARGET_LINK_LIBRARIES(podofouncompress ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofouncompress PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofouncompress ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofouncompress
	RUNTIME DESTINATION "bin")

=== tools/podofoxmp/CMakeLists.txt ===
ADD_EXECUTABLE(podofoxmp podofoxmp.cpp)

TARGET_LINK_LIBRARIES(podofoxmp ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofoxmp PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofoxmp ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofoxmp
	RUNTIME DESTINATION "bin")

=== debian/changelog ===
libpodofo (0.9.8+dfsg-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with CMake 4. Closes: #1113187

 -- Philip Rinn <rinni@debian.org>  Sun, 12 Oct 2025 13:12:51 +0200

libpodofo (0.9.8+dfsg-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on libidn-dev instead of transitional libidn11-dev package.
    Closes: #1086104

 -- Andreas Metzler <ametzler@debian.org>  Sun, 29 Dec 2024 11:47:04 +0100

libpodofo (0.9.8+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062571

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 16:17:29 +0000

libpodofo (0.9.8+dfsg-3) unstable; urgency=medium

  [ YOKOTA Hiroshi ]
  * Fix declaration of operator<< for PoDoFo::PdfString.  Closes: #1012987

  [ Mattia Rizzolo ]
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 21 Aug 2022 16:22:05 +0200

libpodofo (0.9.8+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 06 May 2022 14:32:34 +0200

libpodofo (0.9.8+dfsg-1) experimental; urgency=medium

  * New upstream version 0.9.8+dfsg.
    + CVE-2018-12983 Closes: #916580
    + CVE-2019-10723 Closes: #926667
    + CVE-2019-20093 Closes: #977302
  * Rename library package to match the SONAME.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 04 May 2022 15:48:58 +0200

libpodofo (0.9.7+dfsg-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libfreetype6-dev.

  [ Vagrant Cascadian ]
  * Build with -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON to make the build
    reproducible.  Closes: #1001869

  [ Mattia Rizzolo ]
  * Bump Standards-Version to 4.6.0, no changes needed.
  * Bump copyright year for debian/*.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 02 Jan 2022 18:57:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libpodofo
 Priority: optional
 Section: libdevel
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
+Maintainer: Mattia Rizzolo <mattia@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5),
  cmake,
  debhelper-compat (= 13),
@@ -10,7 +9,7 @@
  libcppunit-dev,
  libfontconfig1-dev,
  libfreetype6-dev,
- libidn11-dev,
+ libidn-dev,
  libjpeg-dev,
  liblua5.1-0-dev,
  libssl-dev,

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+	    -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
+	    -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
 	    -DWANT_FONTCONFIG:BOOL=TRUE \
 	    -DWANT_BOOST:BOOL=1 \
 	    -DPODOFO_BUILD_SHARED:BOOL=TRUE \

=== debian/watch ===
version=4

opts=\
dversionmangle=s/\+(svn[0-9]+|dfsg\d?)//,\
uversionmangle=s/([\d.]+)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
https://sf.net/podofo/podofo@ANY_VERSION@@ARCHIVE_EXT@
